#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: updateConfig.py


import ConfigParser,os

class updateConfig:
	
	def __init__(self,version):
		
		self.section=['option','shortcuts']
		
		self.option=['lrcpath','savelrcpath','download','linenumber','backroundcolor','fontcolor','highlightcolor','fontinfo','proxy','encoder','searchengine','nolrc','includecancel','autoinsert','titlebarinfo','completetag','filterlyrics','nullline','filterrule','filtercap','astrackname','minwidth','horizontal','savetomediapath','searchmediapath','useuslt','lastposition','lrctagtype','lastshowmode','lastistop','remembershowmode','trayicon','trayiconnotify','transparency','opacity','rememberopacity','trayinfotime']
		
		self.option_value=[os.getenv('HOME'),os.getenv('HOME'),'no','3','59,86,115','255,255,255','180,200,255','serif,9,-1,5,50,0,0,0,0,0','no','utf8','ttPlayer','normal','no','no','no','no','no','no','http|lyrics|qq','no','no','360','no','no','no','no','0,0','lyrics3v2','normal','no','no','no','no','no','10','no','5000']
		
		self.shortcuts=['fullscreen','osd','normal','insert','cancel','editor','save','delay','advance','fastbar','refresh']
		
		self.shortcuts_value=['F','O','Esc','F5','F6','E','S','-','+','I','R']
	
	def update(self):
		p=ConfigParser.ConfigParser()
		p.read('%s/.lrcShow-X/lrcShow-X.conf' %os.getenv('HOME'))
		for i in self.section:
			if(p.has_section(i)):
				pass
			else:
				p.add_section(i)
		x=-1
		for j in self.option:
			x+=1
			if(p.has_option('option',j)):
				pass
			else:
				p.set('option',j,self.option_value[x])
				p.write(open('%s/.lrcShow-X/lrcShow-X.conf' %os.getenv('HOME'),'w'))
		y=-1
		for r in self.shortcuts:
			y+=1
			if(p.has_option('shortcuts',r)):
				pass
			else:
				p.set('shortcuts',r,self.shortcuts_value[y])
				p.write(open('%s/.lrcShow-X/lrcShow-X.conf' %os.getenv('HOME'),'w'))
